Func Tray_Settings()
	#Region:::Create GUI
	Global $GUIOpt = GUICreate("JoyTunes V" & $VerInfo, 339, 197)
	GUICtrlCreateTab(8, 8, 324, 160)
	GUICtrlCreateTabItem("Actions")
	GUICtrlSetState(-1, $GUI_SHOW)
	$ListView = GUICtrlCreateListView("Action|Button", 16, 35, 306, 126)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 150)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 152)
	GUICtrlCreateTabItem("Misc.")
	GUICtrlCreateLabel("Use Joypad #:", 16, 40, 73, 25)
	$ComboJoy = GUICtrlCreateCombo("", 88, 40, 49, 25)

	$CheckboxPreventRepeat = GUICtrlCreateCheckbox("Prevent buttons from repeating", 16, 72, 297, 17)
	$Text="Axes Detected:"
	If $CheckX=1 then $Text&="X"
	If $CheckY=1 then $Text&="Y"
	If $CheckZ=1 then $Text&="Z"
	If $CheckR=1 then $Text&="R"
	If $CheckU=1 then $Text&="U"
	If $CheckV=1 then $Text&="V"
	$LabelAxes=GUICtrlCreateLabel($Text, 16, 95, 185, 41)



	$ButtonAbout = GUICtrlCreateButton("About...", 216, 128, 107, 25, $WS_GROUP)
	$LabelURL = GUICtrlCreateLabel("http://michtatools.googlecode.com", 16, 144, 167, 18, $SS_NOTIFY)
	GUICtrlSetColor(-1, 0x0000FF)
	GUICtrlCreateTabItem("")
	$ButtonOK = GUICtrlCreateButton("&OK", 174, 168, 75, 25, $WS_GROUP)
	$ButtonCancel = GUICtrlCreateButton("&Cancel", 254, 168, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion

	#Region:::Set combobox and checkboxes state
	GUICtrlSetData($ComboJoy, "0|1|2|3|4|5", $OptJoyNum)
	_SetCB($CheckboxPreventRepeat, $OptPrevRepeat)
	#EndRegion

	#Region:::Create listview items
	Dim $LVItems[$Actions[0][0] + 1]
	$LVItems[0] = $Actions[0][0]
	For $X = 1 To $LVItems[0]
		$LVItems[$X] = GUICtrlCreateListViewItem($Actions[$X][0] & "|" & $Actions[$X][1], $ListView)
	Next
	#EndRegion ### START Koda GUI section ### Form=

	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $ButtonCancel
				GUIDelete()
				Return
			Case $LabelURL
				ShellExecute("http://michtatools.googlecode.com")
			Case $ButtonOK
				For $X = 1 To $LVItems[0]
					$Read = GUICtrlRead($LVItems[$X])
					$Split = StringSplit(StringTrimRight($Read, 1), "|")
					$Actions[$X][0] = $Split[1]
					$Actions[$X][1] = $Split[2]
				Next
				IniWriteSection("JoyTunes.ini", "Actions", $Actions)
				$OptJoyNum = GUICtrlRead($ComboJoy)

				Global $OptPrevRepeat = _GetCB($CheckboxPreventRepeat)

				IniWrite("JoyTunes.ini", "Settings", "JoyNum", $OptJoyNum)
				IniWrite("JoyTunes.ini", "Settings", "PreventRepeat", $OptPrevRepeat)
				GUIDelete()
				Return
			Case $ButtonAbout
				MsgBox(64, "About", "JoyTunes V" & $VerInfo & @CRLF & "Copyright 2010 Michael Michta", Default, $GUIOpt)
		EndSwitch
		For $X = 1 To $LVItems[0]
			If $nMsg = $LVItems[$X] Then GetAction($LVItems[$X])
		Next
	WEnd
EndFunc   ;==>Tray_Settings

Func GetAction($Item)

	#Region:::Read current selection
	$Read = GUICtrlRead($Item)
	$Split = StringSplit(StringTrimRight($Read, 1), "|")
	#EndRegion

	#Region:::Create GUI and display it
	$Form2 = GUICreate("", 428, 90, Default, Default, -1, BitOR($WS_EX_TOOLWINDOW, $WS_EX_WINDOWEDGE),$GUIOpt)
	GUICtrlCreateLabel("Press a button on the joypad to set it for the action.", 32, 0, 363, 24)
	GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
	$InputAction = GUICtrlCreateInput($Split[2], 155, 32, 121, 21, BitOR($ES_CENTER, $ES_AUTOHSCROLL, $ES_READONLY))
	$ButtonOK = GUICtrlCreateButton("OK", 98, 57, 75, 25, $WS_GROUP)
	$ButtonDisable = GUICtrlCreateButton("Disable", 176, 57, 75, 25, $WS_GROUP)
	$ButtonCancel = GUICtrlCreateButton("Cancel", 254, 57, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_DISABLE, $GUIOpt)
	GUISwitch($Form2)
	#EndRegion

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $ButtonCancel
				GUISetState(@SW_ENABLE, $GUIOpt)
				GUIDelete($Form2)
				Return
			Case $ButtonOK
				GUICtrlSetData($Item, "|" & GUICtrlRead($InputAction))
				GUISetState(@SW_ENABLE, $GUIOpt)
				GUIDelete($Form2)
				Return
			Case $ButtonDisable
				GUICtrlSetData($Item, "|" & "Disabled")
				GUISetState(@SW_ENABLE, $GUIOpt)
				GUIDelete($Form2)
				Return
		EndSwitch
		#Region:::Loop to get buttons and POV
		$Array = _GetJoy($joy, 0)
		#Region:::Check Buttons
		$N = 1
		For $X = 1 To 16
			If BitAND($Array[7], $N) Then GUICtrlSetData($InputAction, "Button" & $X)
			$N *= 2
		Next
		#EndRegion

		#Region:::Check POV
		Switch $Array[6]
			Case 0
				GUICtrlSetData($InputAction, "Up")
				Sleep(100)
			Case 18000
				GUICtrlSetData($InputAction, "Down")
				Sleep(100)
			Case 27000
				GUICtrlSetData($InputAction, "Left")
				Sleep(100)
			Case 9000
				GUICtrlSetData($InputAction, "Right")
				Sleep(100)
			Case 4500
				GUICtrlSetData($InputAction, "Up-Right")
				Sleep(100)
			Case 31500
				GUICtrlSetData($InputAction, "Up-Left")
				Sleep(100)
			Case 13500
				GUICtrlSetData($InputAction, "Down-Right")
				Sleep(100)
			Case 22500
				GUICtrlSetData($InputAction, "Down-Left")
				Sleep(100)
		EndSwitch

		#Region:::Check X
		If $CheckX = 1 Then
			Switch $Array[0]
				Case 0
					GUICtrlSetData($InputAction, "X-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "X+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

		#Region:::Check Y
		If $CheckY = 1 Then
			Switch $Array[1]
				Case 0
					GUICtrlSetData($InputAction, "Y-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "Y+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

		#Region:::Check Z
		If $CheckZ = 1 Then
			Switch $Array[2]
				Case 0
					GUICtrlSetData($InputAction, "Z-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "Z+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

		#Region:::Check R
		If $CheckR = 1 Then
			Switch $Array[3]
				Case 0
					GUICtrlSetData($InputAction, "R-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "R+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

		#Region:::Check U
		If $CheckU = 1 Then
			Switch $Array[4]
				Case 0
					GUICtrlSetData($InputAction, "U-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "U+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

		#Region:::Check V.
		If $CheckV = 1 Then
			Switch $Array[5]
				Case 0
					GUICtrlSetData($InputAction, "V-")
					Sleep(100)
				Case 65535
					GUICtrlSetData($InputAction, "V+")
					Sleep(100)
			EndSwitch
		EndIf
		#EndRegion

	WEnd
EndFunc   ;==>GetAction

Func Tray_Exit()
	Exit
EndFunc   ;==>Tray_Exit