;Functions to make working with checkboxes easier
;2010 Michael Michta
;Licensed under the GNU GPLv3
;V1.0
;Modified to use ints instead of bools
#Include-Once
#include <GUIConstantsEx.au3>
Func _GetCB($hCB)
	Switch GuiCtrlRead($hCB)
		Case $GUI_CHECKED
			Return 1
		Case Else
			Return 0
	EndSwitch
EndFunc

Func _SetCB($hCB,$bVal)
	Switch $bVal
		Case 1
			GuiCtrlSetState($hCB,$GUI_CHECKED)
		Case 0
			GuiCtrlSetState($hCB,$GUI_UNCHECKED)
	EndSwitch
EndFunc